<?php // common.php

// Functions that generate HTML common across several document types.

/** Checks that the $img exists, otherwise returns HTTP 404. */
function assert_img()
{
  global $dirs,$img;
  $c=count($dirs->imagefiles);
  if(0==$c || $img<0 || $img>=$c)
  {
    die("404"); // ?? Fix this to generate a proper error page.
  }
}

/** Emits the set of switcher icons in the #path bar at the top of the screen.
 */
function switcher($doc)
{
  global $img;
  if($img)
    $img_param='&amp;img='.$img;
  $i='<img title="%1$s" alt="%1$s" src="%2$s" width="16" height="16" />';

  echo "&nbsp;&nbsp;\n";

  if($doc=='t')
    $a='<span>%s</span>';
  else
    $a='<a id="nav_t" href="?d=t'.$img_param.'">%s</a>';
  printf($a,sprintf( $i, 'album', get_file(tsize_name().'.gif') ));

  if($doc=='c')
    $a='<span>%s</span>';
  else
    $a='<a id="nav_c" href="?d=c'.$img_param.'">%s</a>';
  printf($a,sprintf( $i, 'carousel', get_file('browse.gif') ));

  if($doc=='s')
    $a='<span>%s</span>';
  else
    $a='<a id="nav_s" href="?d=s'.$img_param.'">%s</a>';
  printf($a,sprintf( $i, 'single', get_file('single.gif') ));
}

/** Emits a small status box, that allows the admin to log in and out, and
 *  displays the Easy Ajax Album logo. */
function status()
{
  global $is_admin,$options;
?>

<div id="status">
 powered by <a title="version <?php
 echo EXA_VERSION ?>" href="<?php
 echo EXA_URL ?>">Easy Ajax Album</a> |
<?php if(intval($options->comments)): ?>
 <a href="?d=l">comments</a> |
<?php endif ?>

<?php if($is_admin): ?>
 <a href="?d=a">prefs</a> |
 <a href="?logout">logout</a>
<?php else: ?>
 <a href="?d=a">login</a>
<?php endif ?>
</div>

<?php
}

function img_load($id)
{
  echo '<img id="'.$id.'" src="'.get_file('load.gif')
    .  '" width="16" height="16" alt="loading" style="display:none" />'."\n";
}

/** Loads a stylesheet called theme.css, if it exists. */
function load_theme()
{
  global $dirs,$options;
  if($options->theme=='DEFAULT')
      return;
  $theme=$dirs->top_album().'/themes/'.$options->theme.'.css';
  if(file_exists($theme))
      echo '<link rel="stylesheet" href="'.$theme.'" type="text/css" />'."\n";
}

?>
