<?php // utilities.php

/** Utility, truncates $x to within $a..$b. */
function minmax($a,$b,$x)
{
  return max($a,min($b,$x));
}

/** Utility, returns $p wrapped to be within 0..($l-1). */
function normalize($p,$l)
{
  return intval($p+$l) % $l;
}

/** Utility function. Gets the value of a variable from a cookie or
 *  a _GET var. In the latter case, set the cookie to match the new value. */
function get_set_cookie($name,$min=0,$max=1,$dflt=0)
{
  if(array_key_exists($name,$_GET))
  {
    $result=minmax($min,$max,intval($_GET[$name]));
    setcookie('exa_'.$name,$result,0,'/');  
  }
  elseif(array_key_exists('exa_'.$name,$_COOKIE))
  {
    $result=minmax($min,$max,intval($_COOKIE['exa_'.$name]));
  }
  else
  {
    $result=$dflt;
  }
  return $result;
}

/** Utility, translates tsize into a name. */
function tsize_name($ts=-1)
{
  global $tsize;
  if($ts<0 || $ts>1)
    $ts=$tsize;
  if($ts) return 'album';
  else    return 'thumb';
}

/** Determines whether $fname is the name an image file.
 *  If so, it return its MIME type. */
function image_mime($fname)
{
  $exts=array(
    '%/[^.][^/]*[.]jpe?g$%i'=>'image/jpeg',
    '%/[^.][^/]*[.]png$%i'=>'image/png',
    '%/[^.][^/]*[.]gif$%i'=>'image/gif'
  );
  foreach($exts as $patt => $mime)
  {
    if( preg_match($patt,$fname) && is_file($fname) && is_readable($fname) )
        return $mime;
  }
  return FALSE;
}

function hsc($s)
{
  return htmlspecialchars($s);
}

$admin_message_text='';
function admin_message($msg)
{
  global $admin_message_text;
  $admin_message_text.='<div class="alert">'.$msg.'</div>';
}

/** Takes an EXIF format rational number and translates to a decimal. */
function rational2dec($rational)
{
  $num=explode('/',$rational);
  if(count($num)==1)
    $result=intval($num[0]);
  if(count($num)==2)
    eval('$result='.intval($num[0]).'/'.intval($num[1]).';');
  return strval($result);
}

/** Turns file basenames into 'nice' HTML. */
function nice($s)
{
  return hsc( str_replace('_',' ',$s) );
}

?>
